#!/bin/sh
# echo loading yaml module 
# https://gist.github.com/pkuczynski/8665367
# read yaml file, second argument (if any) is added prefix

module_load minimize

parse_yaml() {
   local prefix=$2
   local s='[[:space:]]*' w='[a-zA-Z0-9_]*' fs=$(echo @|tr @ '\034')
   sed -ne "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \
        -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p"  $1 |
   awk -F$fs '{
      indent = length($1)/2;
      vname[indent] = $2;
      for (i in vname) {if (i > indent) {delete vname[i]}}
      if (length($3) > 0) {
         vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
         printf("%s%s%s=\"%s\"\n", "'$prefix'",vn, $2, $3);
      }
   }'
}

yaml() {
   dic=$(parse_yaml $1)
   echo $dic
   declare -A test
   while read -d, -r pair; do
      IFS='=' read -r key val <<<"$pair"
      echo adding $val to $key
      test[$key]=$val
   done <<<"$dic\n"
   echo ${test['MP']}
   echo ${test[@]}
}


   # dic=$(python3 -c "import yaml;print(yaml.safe_load(open('$1')))")